Subject: Re: bug#42691: 28.0.50; eval-and-compile

From: Helmut Eller <[email-masked]>
Date: Mon, 03 Aug 2020 14:55:43 +0200

On Mon, Aug 03 2020, Andreas Schwab wrote:

> On Aug 03 2020, Helmut Eller wrote:
>
>> Are you saying this is not a bug in eval-and-compile?
>
> Yes.
>
>> The docstring of eval-and-compile says eval-and-compile is like progn,
>> except that the body it is evaluated at compile-time too.  If it is
>> supposed to work like progn, then the environment should be defined as
>> for progn.
>
> At runtime, yes.

So you are arguing, that the body should be evaluated and macro-expanded
in the null environment.  That's not like progn at all.  Obviously, I
disagree.  I also note that

  emacs -Q --batch -l bug.el

prints:

  Eager macro-expansion failure: (void-function foo)
  Eager macro-expansion failure: (void-function foo)
  Symbol’s function definition is void: foo

which I also consider a bug.

Helmut